<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="礼物名称" prop="name">
        <el-input
            v-model="queryParams.name"
            placeholder="请输入礼物名称"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="giftList" @selection-change="handleSelectionChange">
<!--      <el-table-column type="selection" width="55" align="center"/>-->
      <el-table-column label="礼物ID" align="center" prop="id" v-if="true"/>
      <el-table-column label="礼物名称" align="center" prop="name"/>
      <el-table-column label="礼物价格" align="center" prop="price"/>
      <el-table-column label="礼物图片" align="center" prop="img">
        <template v-slot="scope">
          <image-preview :src="scope.row.img" :width="34" :height="34"/>
        </template>
      </el-table-column>
      <el-table-column label="动态图" align="center" prop="svga" show-overflow-tooltip/>
      <el-table-column label="礼物描述" align="center" prop="desc"/>
      <el-table-column label="排序" align="center" prop="sort"/>
      <el-table-column label="状态" align="center" prop="status">
        <template v-slot="scope">
          <el-switch
              v-model="scope.row.status"
              :active-value="0"
              :inactive-value="1"
              @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="80">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
          >修改</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
    />
    <update-gift-dialog v-if="updateGiftDialogVisible" ref="updateGiftDialog" @refreshDataList="getList"/>
  </div>
</template>

<script>
import {listGift, updateGift} from "@/api/cai/gift";
import UpdateGiftDialog from "@/views/cai/gift/update-gift-dialog.vue";

export default {
  name: "Gift",
  components: { UpdateGiftDialog},
  data() {
    return {
      updateGiftDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 礼物表格数据
      giftList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: undefined,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 新增按钮操作 */
    handleAdd() {
      this.updateGiftDialogVisible = true
      this.$nextTick(() => {
        this.$refs.updateGiftDialog.init()
      })
    },
    handleUpdate(row){
      this.updateGiftDialogVisible = true
      this.$nextTick(() => {
        this.$refs.updateGiftDialog.init(row)
      })
    },
    /** 查询礼物列表 */
    getList() {
      this.loading = true;
      listGift(this.queryParams).then(response => {
        this.giftList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    handleStatusChange(row) {
      let text = row.status === 0 ? '开启' : '取消'
      this.$confirm('确认要' + text + '[' + row.name + ']吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return updateGift({ id: row.id, status: row.status })
      }).then(() => {
        this.$modal.msgSuccess(text + '成功')
      }).catch(function() {
        row.status = row.status === 1 ? 0 : 1
      })
    },
  }
};
</script>
